$.fn.validator = function(opts) {
    /* TODO Remove this in favour of a custom parsley validator */
    $(this).each(function() {
        var $this = $(this);
        var current_validators = $this.data("validators") || [];
        if (current_validators.length === 0) {
            var timer;
            $this.on("keyup", function() {
                clearTimeout(timer);
                timer = setTimeout(function() {
                    clearTimeout(timer);
                    var validators = $this.data("validators");
                    var failed = [];
                    var countdown = validators.length;
                    $.map(validators, function(validator, i) {
                        validator.call($this, function(result) {
                            if ( result ) {
                                if (typeof result == "string") {
                                    result = {
                                        "text": result,
                                        "type": "error"
                                    };
                                }
                                failed.push(result);
                            }
                            if ( --countdown === 0 ) {
                                $this.siblings("ul").remove();
                                $this.parent(".validationWrapper").removeClass("validation-error");
                                $.each(failed, function() {
                                    $this.parent(".validationWrapper").addClass("validation-error");
                                    $this.after(
                                        $("<ul/>").append($("<li/>").html(result.text))
                                    );
                                });
                            }
                        });
                    });

                }, 1000);
            });
        }
        current_validators.push(opts);
        $this.data("validators", current_validators);
        $this.addClass("has_validator");
    });
};
